---
title: Attestation and Assertion
slug: Web/API/Web_Authentication_API/Attestation_and_Assertion
tags:
  - API
  - Guide
  - Web Authentication API
  - WebAuthn
---
<p>{{draft}}{{SeeCompatTable}}{{DefaultAPISidebar("Web Authentication API")}}</p>

<p>There are two different types of certificates used in WebAuthn for registration and authentication. They have similar names and similar purposes, but understanding the differences may be an initial point of confusion. The sections below describe attestation, which happens during registration, and assertion which happens during authentication.</p>

<h2 id="Attestation">Attestation</h2>


<div><span>When an authenticator registers a new key pair with a service, the authenticator signs the public key with an attestation certificate. The attestation certificate is built into the authenticator during manufacturing time and is specific to a device model. That is, all "Samsung Galaxy S8" phones, manufactured at a specific time or particular manufacturing run, have the same attestation certificate.</span></div>

<div> </div>

<div>
<p><span>The attestation </span> <span>is returned through the WebAuthn API as the <a href="/en-US/docs/Web/API/AuthenticatorAttestationResponse">AuthenticatorAttestationResponse</a>. The attestation format contains two basic ArrayBuffers:</span></p>

<ul>
 <li>
  <div><span><strong><span>clientDataJSON</span></strong> - An ArrayBuffer that contains a JSON representation of what the browser saw when being asked to authenticate.</span></div>
 </li>
 <li>
  <div><a href="/en-US/docs/Web/API/AuthenticatorAttestationResponse/attestationObject">attestationObject</a> - Cryptographic attestation that a newly generated keypair was created by that authenticator. Contains authenticator data and an attestation statement. The authenticator data contains an attestedCredentialData field. The attestedCredentialData field contains the credentialId and credentialPublicKey. (The <a href="/en-US/docs/Web/API/AuthenticatorAssertionResponse/authenticatorData">authenticator data</a> is the same structure that is used in the AuthenticatorAssertionResponse. The attestedCredentialData is an optional field used in attestation. It is not included when used in the AuthenticatorAssertionResponse.)</div>
 </li>
</ul>
</div>

<div><span>Different devices have different attestation formats. The <a href="https://www.w3.org/TR/webauthn/#defined-attestation-formats">pre-defined attestation formats in WebAuthn</a> are:</span></div>



<ul>
 <li>
  <div><strong>Packed</strong> - a generic attestation format that is commonly used by devices whose sole function is as a WebAuthn authenticator, such as security keys.</div>
 </li>
 <li>
  <div><strong>TPM</strong> - the Trusted Platform Module (TPM) is a set of specifications from the Trusted Platform Group (TPG). This attestation format is commonly found in desktop computers and is used by Windows Hello as its preferred attestation format.</div>
 </li>
 <li>
  <div><strong>Android Key Attestation</strong> - one of the features added in Android O was Android Key Attestation, which enables the Android operating system to attest to keys.</div>
 </li>
 <li>
  <div><strong>Android SafetyNet</strong> -prior to Android Key Attestation, the only option for Android devices was to create Android SafetyNet attestations</div>
 </li>
 <li>
  <div><strong>FIDO U2F</strong> - security keys that implement the FIDO U2F standard use this format  </div>
 </li>
 <li>
  <div><strong>none</strong> - browsers may prompt users whether they want a site to be allowed to see their attestation data and/or may remove attestation data from the authenticator's response if the `attestation` parameter in `navigator.credentials.create()` is set to `none`</div>
 </li>
</ul>

<div>The purpose of attestation is to cryptographically prove that a newly generated key pair came from a specific device. This provides a root of trust for a newly generated key pair as well as being able to identify the attributes of a device being used (how the private key is protected; if / what kind of biometric is being used; whether a device has been certified; etc.).</div>


<div>It should be noted that while attestation provides the capability for a root of trust, validating the root of trust is frequently not necessary. When registering an authenticator for a new account, typically a Trust On First Use (TOFU) model applies; and when adding an authenticator to an existing account, a user has already been authenticated and has established a secure session.</div>

<h2 id="Assertion">Assertion</h2>

<p><span>When a user chooses to log into a service, the server sends a challenge and the authenticator signs over it with a key pair previously registered to that service. This creates an assertion. Unlike the attestation, the format of the assertion is always the same regardless of the device being used.</span></p>

<p><span>The assertion is returned through the WebAuthn API as the <a href="/en-US/docs/Web/API/AuthenticatorAssertionResponse">AuthenticatorAssertionResponse</a>. The assertion format is fairly simple as it contains four basic ArrayBuffers:</span></p>

<ul>
 <li>
  <div><span><a href="/en-US/docs/Web/API/AuthenticatorResponse/clientDataJSON">clientDataJSON</a> - The same as in attestation. An ArrayBuffer that contains a JSON representation of what the browser saw when being asked to authenticate.</span></div>
 </li>
 <li>
  <div><a href="/en-US/docs/Web/API/AuthenticatorAssertionResponse/authenticatorData">authenticatorData</a> - data created and/or used by the authenticator</div>
 </li>
 <li>
  <div><strong>signature</strong> - a signature over the <span>clientDataJSON and authenticatorData that can be verified with the public key that was created during registration.</span></div>
 </li>
 <li>
  <div><span><strong>userHandle</strong> - Optional. (Nullable) A user identifier. This may be a username, or a hash of a username, etc. Used by a service to give a scope to credentials. Maximum length of 64 bytes. Older authenticators (U2F) do not support this output.</span></div>
 </li>
</ul>

<div>It's important to highlight that the signature for assertion uses a different key pair than attestation. An assertion is signed using the key pair for a service, which was generated during registration. An attestation is signed using the attestation private key and attestation certificate that were burned into all models of the same device. (Except in the case of self-attestation.)</div>

